@echo	off
::---------------------------------------------------------------------------
:: Make tlc.exe
::
:: make Debug		makes debug version
:: make (Release)	makes release version
::
:: Win98	Needs > 256 bytes of environment - add to CONFIG.SYS:
::		shell=command.com /e:1024 /p
::
::		FIND.EXE is required in the path. In Win98 it is in
::		\windows\command.
::
:: WinXP	FIND.EXE is required in the path. In WinXP it is in
::		\windows\system32 (see below).
::
::		Make a new shortcut to make.bat and set the compatibility
::		mode to 'Windows 98/ME'.
::
:: LINK V7.00 option '/OPT:NOWIN98' forces 512 byte section alignment in the
:: PE file which reduces it to the size of LINK V5.12 output. '/OPT:WIN98' is
:: the default and aligns at 4k which makes the executable larger.
::
:: With /DEBUG the linker defaults to /OPT:NOREF which adds all unreferenced
:: functions. For referenced functions only add /OPT:REF. The deprecated
:: /DEBUGTYPE option is left out and the PDB name defaults to <target>.PDB
::---------------------------------------------------------------------------


:: Set Target
::
set TARGET=tlc


:: System.

:: Win98
set path=C:\masm32\bin;C:\windows\command

:: WinXP
::set path=C:\masm32\bin;C:\windows\system32


:: Setup.

if "%1"=="Debug" goto Debug


:Release
::
set ASMOPT=/nologo /c /coff
set LNKOPT=/nologo /SUBSYSTEM:CONSOLE /OPT:NOWIN98 /RELEASE
goto Clean


:Debug
::
set ASMOPT=/nologo /c /coff /Zi /Fl /Sn
::
:: Link options for LINK V5.12
::set LNKOPT=/nologo /SUBSYSTEM:CONSOLE /DEBUG:FULL /DEBUGTYPE:COFF /MAP /OPT:REF
:: Link options for LINK V7.00
set LNKOPT=/nologo /SUBSYSTEM:CONSOLE /DEBUG /MAP /OPT:REF


:Clean

if exist %TARGET%.exe del %TARGET%.exe
if exist *.ilk del *.ilk
if exist *.lst del *.lst
if exist *.map del *.map
if exist *.obj del *.obj
if exist *.pdb del *.pdb
if exist *.rep del *.rep
if exist *.rpt del *.rpt


:: Details.

echo Target: %TARGET% [%1]
::
link /? | find /I "Version 7.00.9466" > nul
if errorlevel 1 goto L512
echo Linker: 7.00.9466
goto ShowOpts
:L512
link /? | find /I "Version 5.12" > nul
if errorlevel 1 goto ShowOpts
echo Linker: 5.12
::
:ShowOpts
echo Asm:    %ASMOPT%
echo Link:   %LNKOPT%


:: Assemble.

ml %ASMOPT% %TARGET%.asm >> asm.rep
if errorlevel 1 goto AsmError
del asm.rep
echo %TARGET%:    assembly ok


:: Link.

link %LNKOPT% %TARGET%.obj >> lnk.rep
if errorlevel 1 goto LnkError
del lnk.rep
echo.        link ok
echo All Ok
echo.
goto TheEnd


:: Errorhandlers.

:AsmError
echo %TARGET%:    ASM ERROR! - sent to ASM.REP and echoed below
type asm.rep | more
goto TheEnd

:LnkError
echo %TARGET%:    LINK ERROR! - sent to LNK.REP


:: Exit.

:TheEnd
if exist *.obj del *.obj
echo.
echo Any key to exit
pause > nul
::---------------------------------------------------------------------------
