;============================================================================
; TLC.ASM
;
; Touch/Lower Case directories and files: V1.00 Aug 2006, DavK.
;
; NB only for Win9x/ME!
;============================================================================




; Model


.586p
.model		flat, stdcall		; MS Windows
option		casemap :none		; case sensitive




; Masm32


.nolist

include		\masm32\include\windows.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\masm32.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\masm32.lib

.listall




; General Constants


; Text output.

TB		equ	09h		; tab
LF		equ	0Ah
CR		equ	0Dh




; Functions.

ScanPath	proto	pszPattern:dword
SetTime		proto	pszObjName:dword




.data




szNewLine	db	CR,LF,0
		align	dword
szTAB		db	TB,0
		align	dword
szSpc		db	" ",0
		align	dword
szHelp		db	"TLC V1.00 August 2006 DavK",CR,LF,
			"Useage:",CR,LF,
			"  tlc /h                        this help",CR,LF,
			"  tlc                           lower case all files and subs",CR,LF,
			"  tlc D:dd/mm/yyyy T:hh:mm:ss   lower case all and touch all",CR,LF,CR,LF,0
		align	dword
szWinBad	db	"tlc: Cannot run on this version of Windows",0
		align	dword
szBadDate	db	"tlc: Date bad or out of range - ""D:<01..31>/<01..12>/<1980..2107>"""
		db	CR,LF,CR,LF,0
		align	dword
szBadTime	db	"tlc: Time bad or out of range - ""T:<00..11>:<00-59>:<00-59>"""
		db	CR,LF,CR,LF,0
		align	dword
szFuture	db	"tlc: DateTime requested is in the future!"
		db	CR,LF,CR,LF,0
		align	dword
szTimeNF	db	"tlc: Time not found",CR,LF,CR,LF,0
		align	dword
szBkSlash	db	"\",0
		align	dword
szParent	db	"..",0			; parent directory
		align	dword
szAllFiles	db	"*",0			; all files
		align	dword

szK32dll	db	"kernel32",0		; assumes ".dll"
		align	dword

pVxDCall0	dd	0			; address of k32 VxDCall0

ddArg1		label	dword
szArg1		db	16 dup (0)
ddArg2		label	dword
szArg2		db	16 dup (0)

ddBuf		label	dword
szBuf		db	8 dup (0)

NewSTime	SYSTEMTIME <0>			; New System Time
NewFTime	FILETIME <0>			; New File Time
CurFTime	FILETIME <0>			; Current File Time
LocFTime	FILETIME <0>			; Local current File Time

DosDate		dw	0			; packed MSDOS Date
DosTime		dw	0			; packed MSDOS Time

fTouch		dd	0			; true to touch




.code




;============================================================================
Tlc:
;============================================================================




; Check Windows version - TLC only for Win9x/ME.


	invoke	GetVersion
	and	eax, 80000004h

	.if	(eax == 0)

		invoke	StdOut, addr szWinBad
		jmp	ExitTLC

	.endif


; Get VxdCall0 address in loaded kernel. As it is undocumented
; (security thru obscurity!!) we have to resort to direct methods.
;
; Get the address of kernel32.dll in memory. From the PE Header	we
; can find the exported functions directory then the address of the
; exported functions. Now we can get the RVA of the first export
; (the first 9 of them are the same). Now extract pointer to
; the first (VxDCall0).


	invoke	GetModuleHandle, addr szK32dll

	.if	(eax == 0)
		invoke	StdOut, addr szWinBad
		jmp	ExitTLC
	.endif

	mov	edx, [eax + IMAGE_DOS_HEADER.e_lfanew]
	add	edx, eax			; PE Header offset

	mov	edx, [edx + IMAGE_NT_HEADERS.OptionalHeader.DataDirectory]
	mov	edx, [edx + eax + IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]

	mov	edx, [edx + eax]              	; first export is VxDCall0
	add	edx, eax			; we have offset
	mov	pVxDCall0, edx			; save it


; Get user instructions.


	invoke	GetCL, 1, addr szArg1

	.if	(eax == 1)

		mov	eax, ddArg1

		.if	(ax == "h/") || (ax == "H/")

			; Help.

			invoke	StdOut, addr szHelp
			jmp	ExitTLC

		.else

			; Check possible date.

			.if	(ax == ":d") || (ax == ":D")

				; Day.

				movzx	eax, word ptr ddArg1 + 2
				mov	ddBuf, eax

				invoke	atodw, addr szBuf
				.if	((sword ptr ax < 1) || (sword ptr ax > 31))
					jmp	BadDate
				.endif
				mov	NewSTime.wDay, ax

				; Month.

				movzx	eax, word ptr ddArg1 + 5
				mov	ddBuf, eax

				invoke	atodw, addr szBuf
				.if	((sword ptr ax < 1) || (sword ptr ax > 12))
					jmp	BadDate
				.endif
				mov	NewSTime.wMonth, ax

				; Year.

				mov	eax, ddArg1 + 8
				mov	ddBuf, eax
				xor	eax, eax
				mov	ddBuf + 4, eax

				invoke	atodw, addr szBuf
				.if	((sword ptr ax < 1980) || (sword ptr ax > 2107))
					jmp	BadDate
				.endif
				mov	NewSTime.wYear, ax

			.else

				; Bad Date.

				BadDate:

				invoke	StdOut, addr szArg1
				invoke	StdOut, addr szNewLine
				invoke	StdOut, addr szBadDate
				jmp	ExitTLC

			.endif

		.endif

	.else

		; Nothing, just do LC.

		mov	fTouch, 0
		jmp	DoScan

	.endif


	; Time.

	invoke	GetCL, 2, addr szArg2

	.if	(eax == 1)

		; Check possible time.

		mov	eax, ddArg2

		.if	(ax == ":t") || (ax == ":T")

			; Hours.

			movzx	eax, word ptr ddArg2 + 2
			mov	ddBuf, eax

			invoke	atodw, addr szBuf
			.if	((sword ptr ax < 0) || (sword ptr ax > 24))
				jmp	BadTime
			.endif
			mov	NewSTime.wHour, ax

			; Minutes.

			movzx	eax, word ptr ddArg2 + 5
			mov	ddBuf, eax

			invoke	atodw, addr szBuf
			.if	((sword ptr ax < 0) || (sword ptr ax > 59))
				jmp	BadTime
			.endif
			mov	NewSTime.wMinute, ax

			; Seconds.

			movzx	eax, word ptr ddArg2 + 8
			mov	ddBuf, eax

			invoke	atodw, addr szBuf
			.if	((sword ptr ax < 0) || (sword ptr ax > 59))
				jmp	BadTime
			.endif
			mov	NewSTime.wSecond, ax

		.else

			; Bad Time.

			BadTime:

			invoke	StdOut, addr szArg2
			invoke	StdOut, addr szNewLine
			invoke	StdOut, addr szBadTime
			jmp	ExitTLC

		.endif

	.else

		; No Time specified.

		invoke	StdOut, addr szTimeNF
		jmp	ExitTLC

	.endif


; Verify the entered Date/Time is not in the future.


	; Convert the new local System time to a new local File time.

	mov	NewSTime.wDayOfWeek, 0
	mov	NewSTime.wMilliseconds, 0
	invoke	SystemTimeToFileTime, addr NewSTime, addr NewFTime

	; Get current UTC System time, convert to local time and compare
	; with new time so we don't stamp into the future.

	invoke	GetSystemTimeAsFileTime, addr CurFTime
	invoke	FileTimeToLocalFileTime, addr CurFTime, addr LocFTime
	invoke	CompareFileTime, addr LocFTime, addr NewFTime

	.if	(sdword ptr eax < 0)

		; Errk, new is in the future!.

		invoke	StdOut, addr szArg1
		invoke	StdOut, addr szSpc
		invoke	StdOut, addr szArg2
		invoke	StdOut, addr szNewLine
		invoke	StdOut, addr szFuture
		jmp	ExitTLC

	.endif


; Convert to Dos DateTime for SetTime.
;
; Note the DOS time is always in Local Time.

	invoke	FileTimeToDosDateTime, addr NewFTime, addr DosDate, addr DosTime


; Flag Touch.

	mov	fTouch, 1


; Do it.

DoScan:

	invoke	ScanPath, addr szAllFiles


; Exit.

ExitTLC:


	xor	eax, eax
	invoke	ExitProcess, eax

;============================================================================




;----------------------------------------------------------------------------
ScanPath	proc	uses ebx esi edi, pszPattern:dword
;-------
;
; Recursive scan of a path, LC and optionally touching all files and dirs.
;
;
; Entry		pszPattern	Pointer to asciiz match pattern
;				"*" returns everything
;
;
; Exit		n/a
;
;
; If FindFirst or FindNext fail they return 0. If no files are found they
; return ERROR_NO_MORE_FILES (= 18) and it seems wfd.cFileName <- 0. Thus
; if an error actually occurs the examination of cFileName will give a 0 so
; the function should safely exit. Note that the doc'd return failure value
; of INVALID_HANDLE_VALUE (-1) causes an endless loop!.
;----------------------------------------------------------------------------


	local	wfd			:WIN32_FIND_DATA
	local	hFind			:dword		; find handle
	local	szDir[MAX_PATH] 	:byte		; full current path
	local	szTmp[MAX_PATH] 	:byte		; full temp path


	lea	edi, szDir
	invoke	GetCurrentDirectory, MAX_PATH, edi

	lea	esi, wfd.cFileName
	xor	eax, eax
	mov	[esi], eax			; need to zero name

	invoke	FindFirstFileA, pszPattern, addr wfd
	mov	hFind, eax


	; Recursive scan.
	;
	; Must use ebx as eax is altered by the switch block.

	mov	ebx, eax

	.while	(sdword ptr ebx > 0)

		mov	eax, [esi]

		; Ignore "..", "." dirs and a null found name.

		.if	((eax != '..') && (eax != '.') && (eax != 0))

			; Lower Case.

			invoke	szLower, esi
			invoke	MoveFile, esi, esi

			; Touch if required.

			mov	eax, fTouch

			.if	(eax)

				invoke	szCopy, edi, addr szTmp
				invoke	szCatStr, addr szTmp, addr szBkSlash
				invoke	szCatStr, addr szTmp, esi
				invoke	SetTime, addr szTmp

			.endif

			; Recurse into subdirectories.

			mov	eax, wfd.dwFileAttributes

			.if	(eax & FILE_ATTRIBUTE_DIRECTORY)

				invoke	SetCurrentDirectory, esi
				invoke	ScanPath, pszPattern

			.endif

		.endif

		invoke	FindNextFileA, hFind, addr wfd
		mov	ebx, eax

	.endw

	invoke	FindClose, hFind

	; Back to parent directory.

	invoke	SetCurrentDirectory, addr szParent


	ret


ScanPath	endp
;----------------------------------------------------------------------------




;----------------------------------------------------------------------------
SetTime		proc	uses ebx esi edi, pszObjName:dword
;------
;
; Set File or Directory time by calling kernel Int21h DOS services.
;
; A failure here just means file/directory time is not updated.
;
;
; Entry		pszObjName	Pointer to asciiz directory name.
;				NB this	must be a full path for DOS.
;
; Exit		eax		0	success
;				<>0	DOS failure code
;
;
; Notes
;
; The Vxd we are calling here is VWIN32.VXD which is amalgamated into VMM.VXD
; when windows is installed. The function we are using is 2A0010h,
; VWIN32_Int21Dispatch, which gives us 32 bit protected mode access to the
; DOS LFN functions. As we know, Windows is a gui on top of MSDOS. Oh, you
; say, but this is a console application. Well just run Pietrik's W32SVSPY
; while you use Explorer and check out the calls into the above function...
; BTW this is one of the many backdoors into the kernel for those baad types
; who may, for some obscure reason, want to hide files and so on.


	; Load object name, date and time details.

	movzx	ecx, DosTime
	movzx	edi, DosDate
	xor	esi, esi			; 1/100 seconds always 0
	mov	edx, pszObjName

	; Set Last Write Time.

	mov	ebx, 3
	mov	eax, 7143h
	pushad
	push	ecx
	push	eax
	push	2A0010h
	call	[pVxDCall0]
	popad
	jc	SFTD_End

	; Set Creation Time.

	mov	ebx, 5
	mov	eax, 7143h
	pushad
	push	ecx
	push	eax
	push	2A0010h
	call	[pVxDCall0]
	popad
	jc	SFTD_End

	; Set Access Time.

	mov	ebx, 7
	mov	eax, 7143h
	push	ecx
	push	eax
	push	2A0010h
	call	[pVxDCall0]
	jc	SFTD_End

	xor	eax, eax

SFTD_End:


	ret


SetTime		endp
;----------------------------------------------------------------------------




if 0
Useful debugging function.

ShowTime	proto	pfTime:dword

include		\masm32\include\user32.inc
includelib	\masm32\lib\user32.lib

szDTFormat	db	"%02d/%02d/%d  %02d:%02d:%02d",0

;----------------------------------------------------------------------------
ShowTime	proc	pfTime:dword
;-------
;
; Convert a FileTime to a SystemTime and output.
;
; Note wsprintf is expecting dword parameters so we must convert the word
; fields of SYSTEMTIME to dwords or the result is wrong.
;
; Also wsprintf requires user32.inc/lib to be included.


	local	Buffer[64]	:byte
	local	sTime		:SYSTEMTIME
	local	Day		:dword
	local	Month		:dword
	local	Year		:dword
	local	Hour		:dword
	local	Minute		:dword
	local	Second		:dword


	; Convert to System time and print.

	invoke	FileTimeToSystemTime, pfTime, addr sTime

	movzx	eax, sTime.wDay
	mov	Day, eax
	movzx	eax, sTime.wMonth
	mov	Month, eax
	movzx	eax, sTime.wYear
	mov	Year, eax
	movzx	eax, sTime.wHour
	mov	Hour, eax
	movzx	eax, sTime.wMinute
	mov	Minute, eax
	movzx	eax, sTime.wSecond
	mov	Second, eax

	invoke	wsprintfA, addr Buffer, addr szDTFormat,
			Day, Month, Year, Hour, Minute, Second

	invoke	StdOut, addr Buffer
	invoke	StdOut, addr szNewLine


	ret


ShowTime	endp
;----------------------------------------------------------------------------
endif




end	Tlc




;============================================================================
